//---------------------------------------------------------------------------

#ifndef DllLoaderH
#define DllLoaderH
//---------------------------------------------------------------------------

class TLoadCounter {
protected:
	int Counter;
public:
	TLoadCounter()
	{
		Counter = 0;
	}
	bool Up()
	{
		if (Counter>0){
			Counter++;
			return false;
		}
		Counter++;
		return true;
	}
	bool Down()
	{
		if (Counter==0)
			return false;
		Counter--;
		return Counter==0;
	}
	int GetCounter() const
		{ return Counter; }
};

// CounterɂDLL̍ă[hh~ꍇ́A
// staticTLoadCounter objectconstructorɓn

class TDllLoader {
protected:
	HINSTANCE hDll;
	TLoadCounter *Counter;	// static object
public:
	TDllLoader(TLoadCounter *counter=0)
		:Counter(counter)
	{
		hDll = NULL;
	}
	virtual ~TDllLoader()
	{
		if (hDll){
			FreeLibrary(hDll);
		}
		if (Counter)
			delete Counter;
	}
	bool IsLoaded() const
	{
		return hDll ? true : false;
	}
	virtual bool Load() = 0;
	void Unload()
	{
		if (Counter && !Counter->Down())
			return;
		if (!hDll)
			return;
		FreeLibrary(hDll);
		hDll = NULL;
	}
protected:
	FARPROC GetProc(LPCSTR name)
	{
		return ::GetProcAddress(hDll, name);
	}
	FARPROC GetProcAddress(LPCSTR name)
	{
		return ::GetProcAddress(hDll, name);
	}
	bool Load(const tchar *dllname)
	{
		if (Counter && !Counter->Up())
			return true;
		if (hDll)
			return true;
		hDll = LoadLibrary(dllname);
		if (!hDll){
			if (Counter)
				Counter->Down();
			return false;
		}
		if (!LoadProcs()){
			FreeLibrary(hDll);
			if (Counter)
				Counter->Down();
			return false;
		}
		return true;
	}
	virtual bool LoadProcs() { return true; }
};

#endif

