//---------------------------------------------------------------------------
#include "tnlib.h"
#pragma hdrstop

#include "nkfdll.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

#include "DllLoader.h"
#include "nkfu.h"

class TNkfLoader : public TDllLoader {
typedef TDllLoader super;
protected:
	//static TLoadCounter counter;
	FNSetNkfOption fnSetNkfOption;
	FNNkfGetKanjiCode fnNkfGetKanjiCode;
	FNGetNkfVersion fnGetNkfVersion;
	FNNkfConvertFileW fnNkfConvertFile;
	FNNkfConvertString fnNkfConvertString;
	FNNkfConvertStream fnNkfConvertStream;
	FNGetNkfGuess fnGetNkfGuess;
	tnstr Path;
public:
	TNkfLoader(const tchar *path)
		:super(new TLoadCounter())	//TODO: łH
		,Path(path)
	{
	}
	virtual bool Load()
	{
		return super::Load(Path);
	}
	const char *GetVersion()
	{
		return fnGetNkfVersion();
	}
	inline void SetOption(const char *option)
	{
		fnSetNkfOption(option);
	}
	void _Convert(const char *s, int len)
	{
		char buf[1024];	//TODO:
		DWORD ret;
		fnNkfConvertString(buf, sizeof(buf), &ret, s, len);
	}
	inline bool ConvertFile(const tchar *filename, const tchar *out)
	{
		return (bool)fnNkfConvertFile(filename, out);
	}
public:
	bool ConvertStream(FNNkfConvertStreamCallback in, FNNkfConvertStreamCallback out, int userdata)
	{
		return (bool)fnNkfConvertStream(in, out, userdata);
	}
	__tnstrA GetGuess()
	{
		const char *g = fnGetNkfGuess();
		return __tnstrA(g);
	}
protected:
	virtual bool LoadProcs()
	{
		fnSetNkfOption = (FNSetNkfOption)GetProc("SetNkfOption");
		fnNkfGetKanjiCode = (FNNkfGetKanjiCode)GetProc("NkfGetKanjiCode");
		fnGetNkfVersion = (FNGetNkfVersion)GetProc("GetNkfVersion");
		fnNkfConvertFile = (FNNkfConvertFileW)GetProc("NkfConvertFileW");
		fnNkfConvertString = (FNNkfConvertString)GetProc("NkfConvertString");
		fnNkfConvertStream = (FNNkfConvertStream)GetProc("NkfConvertStream");
		fnGetNkfGuess = (FNGetNkfGuess)GetProc("GetNkfGuess");
		return fnGetNkfVersion!=NULL;
	}
};

//TLoadCounter TNkfLoader::counter;

//
// TNkf class
//
TNkf::TNkf(const tchar *dllpath)
{
	Dll = new TNkfLoader(dllpath);
	Dll->Load();
#if 0	// for test
	if (IsValid()){
		Dll->GetVersion();
		Dll->_Convert((char*)L"hoge", 4);
		printf("%s\n", nkf.GetGuess().c_str());
		Dll->_Convert("hoge", 4);
		printf("%s\n", nkf.GetGuess().c_str());
	}
#endif
}

TNkf::~TNkf()
{
	if (Dll)
		delete Dll;
}

bool TNkf::IsValid() const
{
	return Dll && Dll->IsLoaded();
}

void TNkf::SetOption(const char *option)
{
	Dll->SetOption(option);
}

bool TNkf::ConvertFile(const tchar *filename, const tchar *out)
{
	return Dll->ConvertFile(filename, out);
}

// convert a file to stream
bool TNkf::ConvertStream(const tchar *filename, FNConvertStreamCallback os)
{
	fp = _wfopen(filename, L"rb");
	if (!fp)
		return false;
	OutStream = os;
	Dll->ConvertStream(cbInFileStream, cbOutStream, (int)this);
	fclose(fp);
	fp = NULL;
	return true;
}
__tnstrA TNkf::GetGuess()
{
	return Dll->GetGuess();
}

int CALLBACK TNkf::cbInFileStream(int ch, int userdata)
{
	TNkf *self = (TNkf*)userdata;
	return fgetc(self->fp);
}
int CALLBACK TNkf::cbOutStream(int ch, int userdata)
{
	TNkf *self = (TNkf*)userdata;
	return self->OutStream(ch, self);
}

int TNkf::Guess(const tchar *str)
{
	if (!Dll->IsLoaded())
		return 0;
	return 0;
}


